<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>AMC13: /work/dan/AMC13/amc13-fw/src/common/IPBUS/ipbus_core/hdl/trans_arb.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">AMC13
   </div>
   <div id="projectbrief">Firmwares for the different applications of the AMC13 uTCA board made at Boston University</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li><li class="navelem"><a class="el" href="dir_50b085d9a531d2f4fb508e8939da4f56.html">IPBUS</a></li><li class="navelem"><a class="el" href="dir_5ece166cf79c4b289e4250a1a1b0f77c.html">ipbus_core</a></li><li class="navelem"><a class="el" href="dir_6b8acfab6d0e4d624803b58e4502256d.html">hdl</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">trans_arb.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">-- trans_arb</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">-- Arbitrates <span class="vhdlkeyword">access</span> <span class="vhdlkeyword">to</span> transactor by multiple packet buffers</span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">-- Dave Newbold, February </span><span class="vhdllogic">2013</span><span class="keyword"></span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">-- $Id$</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classipbus__trans__decl.html">ipbus_trans_decl</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="code" href="classtrans__arb.html">   15</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classtrans__arb.html">trans_arb</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;  <span class="vhdlkeyword">generic</span><span class="vhdlchar">(</span><span class="vhdlchar">NSRC</span><span class="vhdlchar">:</span> <span class="vhdlchar">positive</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;  <span class="vhdlkeyword">port</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="vhdlchar">clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="vhdlchar">rst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="vhdlchar">buf_in</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">ipbus_trans_in_array</span><span class="vhdlchar">(</span><span class="vhdlchar">NSRC</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="vhdlchar">buf_out</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">ipbus_trans_out_array</span><span class="vhdlchar">(</span><span class="vhdlchar">NSRC</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="vhdlchar">trans_out</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">ipbus_trans_in</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="vhdlchar">trans_in</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">ipbus_trans_out</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;  <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">trans_arb</span>;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="code" href="classtrans__arb_1_1rtl.html">   28</a></span>&#160;<span class="vhdlkeyword">architecture</span> rtl <span class="vhdlkeyword">of</span> <a class="code" href="classtrans__arb.html">trans_arb</a> is</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">src</span><span class="vhdlchar">:</span> <span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"> -- Up <span class="vhdlkeyword">to</span> four ports...</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">sel</span><span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">busy</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="vhdlchar">sel</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">to_integer</span><span class="vhdlchar">(</span><span class="vhdlchar">src</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="vhdlkeyword">process</span>(clk)</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clk</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">rst</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                <span class="vhdlchar">busy</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                <span class="vhdlchar">src</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">busy</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;                <span class="vhdlkeyword">if</span> <span class="vhdlchar">buf_in</span><span class="vhdlchar">(</span><span class="vhdlchar">sel</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">pkt_rdy</span> <span class="vhdlchar">/=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                    <span class="vhdlkeyword">if</span> <span class="vhdlchar">src</span> <span class="vhdlchar">/=</span> <span class="vhdlchar">(</span><span class="vhdlchar">NSRC</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                        <span class="vhdlchar">src</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">src</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;                    <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                        <span class="vhdlchar">src</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;                    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;                <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;                    <span class="vhdlchar">busy</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">.</span><span class="vhdlchar">pkt_done</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                <span class="vhdlchar">busy</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="vhdlchar">trans_out</span><span class="vhdlchar">.</span><span class="vhdlchar">pkt_rdy</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">buf_in</span><span class="vhdlchar">(</span><span class="vhdlchar">sel</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">pkt_rdy</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="vhdlchar">trans_out</span><span class="vhdlchar">.</span><span class="vhdlchar">rdata</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">buf_in</span><span class="vhdlchar">(</span><span class="vhdlchar">sel</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">rdata</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="vhdlchar">trans_out</span><span class="vhdlchar">.</span><span class="vhdlchar">busy</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">buf_in</span><span class="vhdlchar">(</span><span class="vhdlchar">sel</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">busy</span>;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="vhdlchar">busgen</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">for</span> <span class="vhdlchar">i</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">NSRC</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="vhdlkeyword">  begin</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="vhdlchar">buf_out</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">pkt_done</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">.</span><span class="vhdlchar">pkt_done</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">sel</span> <span class="vhdlchar">=</span> <span class="vhdlchar">i</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="vhdlchar">buf_out</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">wdata</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">.</span><span class="vhdlchar">wdata</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="vhdlchar">buf_out</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">waddr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">.</span><span class="vhdlchar">waddr</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="vhdlchar">buf_out</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">raddr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">.</span><span class="vhdlchar">raddr</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="vhdlchar">buf_out</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span><span class="vhdlchar">.</span><span class="vhdlchar">we</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">.</span><span class="vhdlchar">we</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">sel</span> <span class="vhdlchar">=</span> <span class="vhdlchar">i</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;      </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">rtl</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Sep 8 2021 11:22:41 for AMC13 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
